﻿using Android.Content.PM;
using AuditManager.Droid.Helpers;
using AuditManager.Interfaces;
using Xamarin.Forms;

[assembly: Dependency(typeof(AppVersionProvider))]
namespace AuditManager.Droid.Helpers
{
    public class AppVersionProvider : IAppVersionProvider
    {
        public string GetVersion()
        {
            var context = Android.App.Application.Context;

            PackageManager manager = context.PackageManager;
            PackageInfo info = manager.GetPackageInfo(context.PackageName, 0);

            return info.VersionName;
        }

        public int GetBuild()
        {
            var context = Android.App.Application.Context;

            PackageManager manager = context.PackageManager;
            PackageInfo info = manager.GetPackageInfo(context.PackageName, 0);

            return info.VersionCode;
        }
    }
}