using Android.App;
using Android.Content.PM;
using Android.OS;
using Android.Runtime;
using Android.Views;
using FFImageLoading.Forms.Platform;
using ImageCircle.Forms.Plugin.Droid;
using ModernHttpClient;
using Plugin.Permissions;
using Syncfusion.XForms.Android.PopupLayout;
using Xamarin.Forms;
using Xamarin.Forms.Platform.Android;

namespace AuditManager.Droid
{
    [Activity(Label = "@string/AppDisplayName",
        Icon = "@drawable/icon",
        Theme = "@style/Theme.Splash",
        MainLauncher = true,
        ConfigurationChanges = ConfigChanges.ScreenSize | ConfigChanges.Orientation,
        ScreenOrientation = ScreenOrientation.User,
        LaunchMode = LaunchMode.SingleTop
    )]
    public class MainActivity : FormsAppCompatActivity
    {
        protected override void OnCreate(Bundle bundle)
        {
            TabLayoutResource = Resource.Layout.Tabbar;
            ToolbarResource = Resource.Layout.Toolbar;

            base.Window.RequestFeature(WindowFeatures.ActionBar);
            base.SetTheme(Resource.Style.MainTheme);

            base.OnCreate(bundle);

            // Initializing FFImageLoading
            CachedImageRenderer.Init(enableFastRenderer: false);

            NativeMessageHandler.verifyHostnameCallback = (hostname, session) =>
            {
                return true;
            };

            Forms.Init(this, bundle);
            ImageCircleRenderer.Init();
            SfPopupLayoutRenderer.Init();
            LoadApplication(new App());
        }

        public override void OnRequestPermissionsResult(int requestCode, string[] permissions, [GeneratedEnum] Permission[] grantResults)
        {
            PermissionsImplementation.Current.OnRequestPermissionsResult(requestCode, permissions, grantResults);
            base.OnRequestPermissionsResult(requestCode, permissions, grantResults);
        }
    }
}

