﻿using AuditManager.Helpers;
using AuditManager.Shared.Constants;
using AuditManager.Views;
using Syncfusion.XForms.Buttons;
using Syncfusion.XForms.PopupLayout;
using System;
using System.Collections.ObjectModel;
using Xamarin.Forms;

namespace AuditManager.Behaviors
{
    public class QuestionarioContentViewBehavior : Behavior<ContentView>
    {
        private SfPopupLayout popupLayout;

        public QuestionarioContentViewBehavior()
        {

        }

        //public static readonly BindableProperty CommandProperty = BindableProperty.Create("Parameter", typeof(object), typeof(QuestionarioBehavior), null);

        //public object Parameter
        //{
        //    get { return GetValue(CommandProperty); }
        //    set { SetValue(CommandProperty, value); }
        //}

        protected override void OnAttachedTo(ContentView bindable)
        {
            base.OnAttachedTo(bindable);
            AddTapGeture(bindable);
        }

        private void AddTapGeture(ContentView infoButton)
        {
            var tapGesture = new TapGestureRecognizer();
            (infoButton as ContentView).GestureRecognizers.Add(tapGesture);
            tapGesture.Tapped += InfoButton_Tapped;
        }

        private void InfoButton_Tapped(object sender, EventArgs e)
        {
            popupLayout = (new ContextMenuView()).Content as SfPopupLayout;

            ContentView item = sender as ContentView;
            popupLayout.BindingContext = item.BindingContext;
            popupLayout.ShowRelativeToView(item, RelativePosition.AlignBottomRight, 0, 0);
        }

        protected override void OnDetachingFrom(ContentView bindable)
        {
            base.OnDetachingFrom(bindable);
        }
    }

    public class QuestionarioSfSegmentedControlBehavior : Behavior<SfSegmentedControl>
    {
        private SfSegmentedControl sfSegmentedControl;

        public QuestionarioSfSegmentedControlBehavior()
        {

        }

        protected override void OnAttachedTo(SfSegmentedControl bindable)
        {
            base.OnAttachedTo(bindable);

            sfSegmentedControl = bindable;
            sfSegmentedControl.ItemsSource = new ObservableCollection<View>()
            {
                new Button()
                {
                    Text = "OK",
                    TextColor = FunctionsHelper.GetColorFromResource("WhiteColor"),
                    BackgroundColor = FunctionsHelper.GetColorFromResource(Constants.ColoreRispostaOK),
                    CornerRadius = 20,
                    FontSize = 10,
                    VerticalOptions = LayoutOptions.CenterAndExpand
                },
                new Button()
                {
                    Text = "KO",
                    TextColor = FunctionsHelper.GetColorFromResource("WhiteColor"),
                    BackgroundColor = FunctionsHelper.GetColorFromResource(Constants.ColoreRispostaKO),
                    HeightRequest = 30,
                    WidthRequest = 30,
                    CornerRadius = 15,
                    FontSize = 12,
                    VerticalOptions = LayoutOptions.Center
                }
            };

        }

        protected override void OnDetachingFrom(SfSegmentedControl bindable)
        {
            base.OnDetachingFrom(bindable);
        }
    }
}