﻿using AuditManager.Helpers;
using AuditManager.Models.Tables;
using AuditManager.Views.Custom;
using Syncfusion.XForms.Buttons;
using System.Collections.ObjectModel;
using System.Reflection;
using Xamarin.Forms;

namespace AuditManager.Data
{
    public class AuditDomandeRisposteXF : AuditDomandeRisposte
    {
        private bool _IsEnabled;
        public bool IsEnabled
        {
            get { return _IsEnabled; }
            set
            {
                _IsEnabled = value;
                OnPropertyChanged(nameof(IsEnabled));
            }
        }

        public Command<RispostaParametro> RispostaCommand { get; set; }
        //public Command<object> RispostaCommand1 { get; set; }

        public RispostaParametro RispostaParametro { get; set; }
        public RispostaParametro RispostaParametroOK { get; set; }
        public RispostaParametro RispostaParametroKO { get; set; }
        public RispostaParametro RispostaParametroNA { get; set; }
        public RispostaParametro RispostaParametroNT { get; set; }

        private string _ColoreBackgroundBottoneOK;
        public string ColoreBackgroundBottoneOK
        {
            get { return _ColoreBackgroundBottoneOK; }
            set
            {
                _ColoreBackgroundBottoneOK = value;
                OnPropertyChanged(nameof(ColoreBackgroundBottoneOK));
            }
        }

        private string _ColoreBackgroundBottoneKO;
        public string ColoreBackgroundBottoneKO
        {
            get { return _ColoreBackgroundBottoneKO; }
            set
            {
                _ColoreBackgroundBottoneKO = value;
                OnPropertyChanged(nameof(ColoreBackgroundBottoneKO));
            }
        }

        private string _ColoreBackgroundBottoneNA;
        public string ColoreBackgroundBottoneNA
        {
            get { return _ColoreBackgroundBottoneNA; }
            set
            {
                _ColoreBackgroundBottoneNA = value;
                OnPropertyChanged(nameof(ColoreBackgroundBottoneNA));
            }
        }

        private string _ColoreBackgroundBottoneNT;
        public string ColoreBackgroundBottoneNT
        {
            get { return _ColoreBackgroundBottoneNT; }
            set
            {
                _ColoreBackgroundBottoneNT = value;
                OnPropertyChanged(nameof(ColoreBackgroundBottoneNT));
            }
        }

        private string _ColoreTestoBottoneOK;
        public string ColoreTestoBottoneOK
        {
            get { return _ColoreTestoBottoneOK; }
            set
            {
                _ColoreTestoBottoneOK = value;
                OnPropertyChanged(nameof(ColoreTestoBottoneOK));
            }
        }

        private string _ColoreTestoBottoneKO;
        public string ColoreTestoBottoneKO
        {
            get { return _ColoreTestoBottoneKO; }
            set
            {
                _ColoreTestoBottoneKO = value;
                OnPropertyChanged(nameof(ColoreTestoBottoneKO));
            }
        }

        private string _ColoreTestoBottoneNA;
        public string ColoreTestoBottoneNA
        {
            get { return _ColoreTestoBottoneNA; }
            set
            {
                _ColoreTestoBottoneNA = value;
                OnPropertyChanged(nameof(ColoreTestoBottoneNA));
            }
        }

        private string _ColoreTestoBottoneNT;
        public string ColoreTestoBottoneNT
        {
            get { return _ColoreTestoBottoneNT; }
            set
            {
                _ColoreTestoBottoneNT = value;
                OnPropertyChanged(nameof(ColoreTestoBottoneNT));
            }
        }

        //public ObservableCollection<SfSegmentItem> ButtonColors { get; set; }

        public AuditDomandeRisposteXF()
        {

        }

        public AuditDomandeRisposteXF(AuditDomandeRisposte auditDomandeRisposte)
        {
            foreach (PropertyInfo propertyInfo in auditDomandeRisposte.GetType().GetProperties())
            {
                object secondValue = propertyInfo.GetValue(auditDomandeRisposte, null);
                propertyInfo.SetValue(this, secondValue);
            }

            //var fontFamily = "SegmentIcon.ttf";

            //if (Device.RuntimePlatform == Device.UWP)
            //    fontFamily = $"ms-appx:///AuditManager.UWP/Assets/Fonts/SegmentIcon.ttf#segment2";
            //else if (Device.RuntimePlatform == Device.iOS)
            //    fontFamily = "segment2";

            //var SegoeFontFamily = "Segoe_MDL2_Assets.ttf";

            //if (Device.RuntimePlatform == Device.UWP)
            //    SegoeFontFamily = $"ms-appx:///AuditManager.UWP/Assets/Fonts/Segoe_MDL2_Assets.ttf#Segoe MDL2 Assets";
            //else if (Device.RuntimePlatform == Device.iOS)
            //    SegoeFontFamily = "Segoe MDL2 Assets";

            //ButtonColors = new ObservableCollection<SfSegmentItem>
            //{
            //    new CustomSfSegmentItem() { IconFont = "\uE91F",  FontIconFontColor = FunctionsHelper.GetColorFromResource("ColoreRispostaOK"), Text="Square", FontIconFontSize = 32,  FontIconFontFamily = SegoeFontFamily},
            //    new CustomSfSegmentItem() { IconFont = "\uE91F",  FontIconFontColor = FunctionsHelper.GetColorFromResource("ColoreRispostaKO"), Text="Square", FontIconFontSize = 32,  FontIconFontFamily = SegoeFontFamily},
            //    new CustomSfSegmentItem() { IconFont = "\uE91F",  FontIconFontColor = FunctionsHelper.GetColorFromResource("ColoreRispostaNA"), Text="Square", FontIconFontSize = 32,  FontIconFontFamily = SegoeFontFamily},
            //    new CustomSfSegmentItem() { IconFont = "\uE91F",  FontIconFontColor = FunctionsHelper.GetColorFromResource("ColoreRispostaNT"), Text="Square", FontIconFontSize = 32,  FontIconFontFamily = SegoeFontFamily},
            //    new CustomSfSegmentItem() { IconFont = "\uE91F",  FontIconFontColor = FunctionsHelper.GetColorFromResource("ColoreDV"), Text="Square", FontIconFontSize = 32,  FontIconFontFamily = SegoeFontFamily}
            //};
        }
    }

    public class RispostaParametro
    {
        public int IdAudit { get; set; }
        public int IdCategoria { get; set; }

        public int IdDomanda { get; set; }
        public int IdTipoDomanda { get; set; }
        public int IdRisposta { get; set; }

        public int? Attributo { get; set; }
        public string Risposta { get; set; }

        public RispostaParametro()
        {

        }

        public RispostaParametro(int idAudit, int idCategoria, int idDomanda, int idTipoDomanda, int idRisposta, int? attributo, string risposta)
        {
            IdAudit = idAudit;
            IdCategoria = idCategoria;
            IdDomanda = idDomanda;
            IdTipoDomanda = idTipoDomanda;
            IdRisposta = idRisposta;
            Attributo = attributo;
            Risposta = risposta;
        }
    }
}