﻿using Syncfusion.XForms.DataForm;
using System;
using System.Collections;
using System.Collections.Generic;
using Xamarin.Forms.Internals;

namespace AuditManager.Models
{
    [Serializable]
    [Preserve(AllMembers = true)]
    public class LoginModel : BaseModel
    {
        #region Fields       
        private string email;
        private string password;
        private string deviceId;
        private string deviceName;
        #endregion

        #region Constructor
        public LoginModel()
        {
#if DEBUG
            Email = "m.comi@focusinformatica.com";
            Password = "Mcomi2018!";
#endif
            if (!string.IsNullOrEmpty(Settings.DeviceId))
            {
                DeviceId = Settings.DeviceId;
                DeviceName = Settings.DeviceName;
            }
        }
        #endregion

        [Display(Name = "StringEmail", Prompt = "EnterEmailAddress", ResourceType = typeof(Resx.AppResources))]
        [EmailAddress(ErrorMessageResourceName = "EmailErrorMessage", ErrorMessageResourceType = typeof(Resx.AppResources))]
        public string Email
        {
            get { return email; }
            set
            {
                email = value;
                RaisePropertyChanged(nameof(Email));
                RaiseErrorChanged(nameof(Email));
            }
        }

        [Display(Name = "StringPassword", Prompt = "EnterPassword", ResourceType = typeof(Resx.AppResources))]
        [Required(AllowEmptyStrings = false, ErrorMessage = "", ErrorMessageResourceName = "PasswordErrorMessage", ErrorMessageResourceType = typeof(Resx.AppResources))]
        [DataType(DataType.Password)]
        public string Password
        {
            get { return password; }
            set
            {
                password = value;
                RaisePropertyChanged(nameof(Password));
                RaiseErrorChanged(nameof(Password));
            }
        }

        public string DeviceId
        {
            get { return deviceId; }
            set
            {
                deviceId = value;
                RaisePropertyChanged(nameof(DeviceId));
                RaiseErrorChanged(nameof(DeviceId));
            }
        }

        public string DeviceName
        {
            get { return deviceName; }
            set
            {
                deviceName = value;
                RaisePropertyChanged(nameof(DeviceName));
                RaiseErrorChanged(nameof(DeviceName));
            }
        }

        public override IEnumerable GetErrors(string propertyName)
        {
            if (propertyName == null)
                return null;

            List<string> errors = new List<string>();

            if (propertyName == "Password")
            {
                if (string.IsNullOrEmpty(Password))
                    return string.Empty;

                var error = string.Empty;

                if (!propErrors.TryGetValue(propertyName, out errors) && !string.IsNullOrEmpty(error))
                {
                    errors = new List<string>();
                    errors.Add(error);
                    propErrors.Add("Password", errors);
                }
                else if (propErrors.TryGetValue(propertyName, out errors))
                {
                    errors.Clear();
                    propErrors.Remove(propertyName);
                }
            }

            if (propErrors.TryGetValue(propertyName, out errors))
                return errors;

            return null;
        }
    }
}
