﻿using AuditManager.Helpers;
using AuditManager.Models;
using AuditManager.Models.Tables;
using AuditManager.Shared.Types;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace AuditManager.ViewModels
{
    public class SplashScreenViewModel : BaseViewModel
    {
        private LoginModel login;
        public LoginModel Login
        {
            get { return login; }
            set { login = value; }
        }

        public SplashScreenViewModel() : base()
        {
            Login = new LoginModel
            {
                DeviceId = Settings.DeviceId,
                DeviceName = Settings.DeviceName,
                Email = Settings.User,
                Password = Settings.Password
            };

            Settings.SetTheme((Themes)Settings.Theme);

            CheckLoginAsync();
        }

        private async Task CheckLoginAsync()
        {
            if (Settings.IsConnected && Settings.IsOnline)
            {
                ApiResponse<Utenti> loginResponse = await ns.Login(Login);

                if (loginResponse.IsSuccess)
                {
                    ApiResponse<bool> syncDatabase = await SyncDB();
                }
                else
                {
                    if (loginResponse.Status != ApiStatus.NoConnectivity)
                        FunctionsHelper.Logout();
                }
            }

            Application.Current.MainPage = App.GetMainPage();
        }
    }
}