﻿using Syncfusion.XForms.PopupLayout;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace AuditManager.Views
{
    [XamlCompilation(XamlCompilationOptions.Compile)]
    public partial class PopUpLogout : PopupView
    {
        public static readonly BindableProperty AcceptCommandProperty = BindableProperty.Create(
            propertyName: nameof(AcceptCommand),
            returnType: typeof(Command),
            declaringType: typeof(PopUpLogout),
            defaultValue: null,
            defaultBindingMode: BindingMode.TwoWay,
            propertyChanged: AcceptCommandPropertyChanged);

        public new Command AcceptCommand { get { return (Command)GetValue(AcceptCommandProperty); } set { SetValue(AcceptCommandProperty, value); } }

        private static void AcceptCommandPropertyChanged(BindableObject bindable, object oldValue, object newValue)
        {
            var control = (PopUpLogout)bindable;
            control.PopUpLogoutView.AcceptCommand = (Command)newValue;
        }

        public static readonly BindableProperty DeclineCommandProperty = BindableProperty.Create(
            propertyName: nameof(DeclineCommand),
            returnType: typeof(Command),
            declaringType: typeof(PopUpLogout),
            defaultValue: null,
            defaultBindingMode: BindingMode.TwoWay,
            propertyChanged: DeclineCommandPropertyChanged);

        public new Command DeclineCommand { get { return (Command)GetValue(DeclineCommandProperty); } set { SetValue(DeclineCommandProperty, value); } }

        private static void DeclineCommandPropertyChanged(BindableObject bindable, object oldValue, object newValue)
        {
            var control = (PopUpLogout)bindable;
            control.PopUpLogoutView.DeclineCommand = (Command)newValue;
        }

        public PopUpLogout()
        {
            InitializeComponent();
        }
    }
}