﻿using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace AuditManager.Views
{
    [XamlCompilation(XamlCompilationOptions.Compile)]
    public partial class RadioButtonView : ContentView
    {
        public static readonly BindableProperty TestoProperty = BindableProperty.Create(
           propertyName: nameof(Testo),
           returnType: typeof(string),
           declaringType: typeof(RadioButtonView),
           defaultValue: string.Empty,
           defaultBindingMode: BindingMode.TwoWay,
           propertyChanged: TestoPropertyChanged);

        public string Testo { get { return GetValue(TestoProperty).ToString(); } set { SetValue(TestoProperty, value); } }

        private static void TestoPropertyChanged(BindableObject bindable, object oldValue, object newValue)
        {
            var control = (RadioButtonView)bindable;
            control.label.Text = newValue.ToString();
        }

        public static readonly BindableProperty ColoreProperty = BindableProperty.Create(
            propertyName: nameof(Colore),
            returnType: typeof(Color),
            declaringType: typeof(RadioButtonView),
            defaultValue: Application.Current.Resources["DarkTextColor"],
            defaultBindingMode: BindingMode.TwoWay,
            propertyChanged: ColorePropertyChanged);

        public Color Colore { get { return (Color)GetValue(ColoreProperty); } set { SetValue(ColoreProperty, value); } }

        private static void ColorePropertyChanged(BindableObject bindable, object oldValue, object newValue)
        {
            var control = (RadioButtonView)bindable;
            control.layout.BackgroundColor = (Color)newValue;
        }


        public RadioButtonView()
        {
            InitializeComponent();
        }
    }
}