﻿using AuditManager.Helpers;
using AuditManager.Models;
using System;
using System.Threading;
using System.Threading.Tasks;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace AuditManager.Views
{
    [XamlCompilation(XamlCompilationOptions.Compile)]
    public partial class TopHeaderBar : ContentView
    {
        private bool _playing = false;
        private Animation _animation;
        private Animation _animation1;

        public TopHeaderBar()
        {
            InitializeComponent();
        }

        #region PopupMenu
        private void ClickToShowPopup_Clicked(object sender, EventArgs e)
        {
            popupMenu.Show();
        }

        private void Offline_Tapped(object sender, EventArgs e)
        {
            MessagingCenter.Send(this, PopUpMessages.PopUpOffline.ToString());
            popupMenu.Dismiss();
        }

        private void Sync_Tapped(object sender, EventArgs e)
        {
            MessagingCenter.Send(this, PopUpMessages.PopUpSync.ToString());
            popupMenu.Dismiss();
        }

        private void Completa_Tapped(object sender, EventArgs e)
        {
            MessagingCenter.Send(this, PopUpMessages.PopUpCompleta.ToString());
            popupMenu.Dismiss();
        }

        private void ListaLavori_Tapped(object sender, EventArgs e)
        {
            MessagingCenter.Send(this, PopUpMessages.PopUpListaLavori.ToString());
            popupMenu.Dismiss();
        }

        private void Convalida_Tapped(object sender, EventArgs e)
        {
            MessagingCenter.Send(this, PopUpMessages.PopUpConvalida.ToString());
            popupMenu.Dismiss();
        }

        private void Stampa_Tapped(object sender, EventArgs e)
        {
            MessagingCenter.Send(this, PopUpMessages.PopUpStampa.ToString());
            popupMenu.Dismiss();
        }

        private void NotificaListaLavori_Tapped(object sender, EventArgs e)
        {
            MessagingCenter.Send(this, PopUpMessages.PopUpNotificaLista.ToString());
            popupMenu.Dismiss();
        }

        private void Dettaglio_Tapped(object sender, EventArgs e)
        {
            MessagingCenter.Send(this, PopUpMessages.PopUpDettaglio.ToString());
            popupMenu.Dismiss();
        }

        private void RispostaMultipla_Tapped(object sender, EventArgs e)
        {
            MessagingCenter.Send(this, PopUpMessages.PopUpRispostaMultipla.ToString());
            popupMenu.Dismiss();
        }

        private void AllegatoPrincipale_Tapped(object sender, EventArgs e)
        {
            MessagingCenter.Send(this, PopUpMessages.PopUpAllegatoPrincipale.ToString());
            popupMenu.Dismiss();
        }
        #endregion

        public void Start()
        {
            _animation = new Animation();

            _animation1 = new Animation(v => syncButton.RotationX = v, 0, 360, Easing.Linear);

            _animation.Add(0, 1, _animation1);

            _playing = true;
            _animation.Commit(syncButton, "Loop", length: 1000, repeat: () => _playing);
        }

        public void Stop()
        {
            _playing = false;
            _animation = null;
        }
    }
}