using Xamarin.Forms;

namespace AuditManager.Views
{
    public partial class CustomActivityIndicator : ContentView
	{
		private bool _playing = false;
		private Animation _animation;
		private Animation _animation1;
        private Animation _animation2;

        public CustomActivityIndicator()
		{
			InitializeComponent();
		}

		public void Start()
		{
            _animation = new Animation();

            _animation1 = new Animation(
				callback: d => Wrapper.RotationY = d,
				start: 0,
				end: 360,
				easing: Easing.Linear);
            _animation2 = new Animation(
                callback: d => Wrapper.RotationX = d,
                start: 0,
                end: 360,
                easing: Easing.Linear);

            _animation.Add(0, 0.5, _animation1);
            _animation.Add(0.5, 1, _animation2);

            _playing = true;
			_animation.Commit(Wrapper, "Loop", length: 1000, repeat: () => _playing);
		}

		public void Stop()
		{
			_playing = false;
			_animation = null;
		}
	}
}

