﻿using AuditManager.Models;
using AuditManager.ViewModels;
using Xamarin.Forms;
using Xamarin.Forms.Internals;
using Xamarin.Forms.Xaml;

namespace AuditManager.Views
{
    [Preserve(AllMembers = true)]
    [XamlCompilation(XamlCompilationOptions.Compile)]
    public partial class LoginPage : BasePage
    {
        private bool isPageLoaded = true;

        private LoginViewModel Modello
        {
            get { return BindingContext as LoginViewModel; }
        }

        public LoginPage() : base()
        {
            InitializeComponent();
        }

        protected override void OnAppearing()
        {
            base.OnAppearing();

            MessagingCenter.Subscribe<LoginViewModel, AlertModel>(this, Messages.DisplayAlertMessage.ToString(), async (sender, alertValues) =>
            {
                AlertVibrate(alertValues);
            });

            MessagingCenter.Subscribe<LoginViewModel>(this, Messages.OperationStarted.ToString(), (sender) =>
            {
                Indicator.Start();
            });

            MessagingCenter.Subscribe<LoginViewModel>(this, Messages.OperationFinished.ToString(), (sender) =>
            {
                Indicator.Stop();
            });

            isPageLoaded = true;
        }

        protected override void OnDisappearing()
        {
            isPageLoaded = false;

            base.OnDisappearing();

            MessagingCenter.Unsubscribe<LoginViewModel, AlertModel>(this, Messages.DisplayAlertMessage.ToString());
            MessagingCenter.Unsubscribe<LoginViewModel>(this, Messages.ConnectionMessage.ToString());
            MessagingCenter.Unsubscribe<LoginViewModel>(this, Messages.OperationFinished.ToString());

            //BindingContext = null;
        }
    }
}