﻿using AuditManager.Shared.Attributes;
using SQLite;
using System.Net;

namespace AuditManager.Models.Tables
{
    [Table("Categorie"), TableReplication(Replicate = true)]
    public class Categorie : BaseTable
    {
        [NotNull]
        public int IdCategoria { get; set; }

        private string _CodCategoria;
        [Indexed]
        public string CodCategoria
        {
            get { return _CodCategoria; }
            set { _CodCategoria = WebUtility.HtmlDecode(value); }
        }

        private string _DescCategoria;
        [Indexed]
        public string DescCategoria
        {
            get { return _DescCategoria; }
            set { _DescCategoria = WebUtility.HtmlDecode(value); }
        }

        public string Immagine { get; set; }
        public bool Readonly { get; set; }

        [Indexed]
        public int IdTipoAudit { get; set; }


        public Categorie()
        {
        }
    }
}
