﻿using AuditManager.Shared.Attributes;
using SQLite;
using System.Net;

namespace AuditManager.Models.Tables
{
    [Table("Domande"), TableReplication(Replicate = true)]
    public class Domande : BaseTable
    {
        [NotNull]
        public int IdDomanda { get; set; }
        [NotNull]
        public int IdTipoDomanda { get; set; }
        [NotNull]
        public int IdCategoria { get; set; }

        private string _Testo;
        [NotNull]
        public string Testo
        {
            get { return _Testo; }
            set { _Testo = WebUtility.HtmlDecode(value); }
        }

        public string Valori { get; set; }

        private string _Help;
        public string Help
        {
            get
            {
                return _Help;
            }
            set
            {
                _Help = WebUtility.HtmlDecode(value);
            }
        }


        private string _HelpAllegato;
        public string HelpAllegato
        {
            get
            {
                return _HelpAllegato;
            }
            set
            {
                _HelpAllegato = WebUtility.HtmlDecode(value);
            }
        }

        public int? IdDomandaParent { get; set; }
        public string ValoreDomandaParent { get; set; }
        public int? IdCriticita { get; set; }
        public int? Attributo { get; set; }
        public string Punteggio { get; set; }
        public string CodPuntoNorma { get; set; }
        public string DesPuntoNorma { get; set; }
        public string IdProcessoInterno { get; set; }
        public string RisposteNcDft { get; set; }
        [NotNull]
        public int NrCampiNote { get; set; }
        [NotNull]
        public string PlaceholderNote { get; set; }
        [NotNull]
        public string TipoCampiNote { get; set; }
        public string RisposteDft { get; set; }

        public int? IdRisposteDettaglioMacroAttributo1 { get; set; }
        public int? IdRisposteDettaglioAttributo1 { get; set; }
        public int? IdRisposteDettaglioMacroAttributo2 { get; set; }
        public int? IdRisposteDettaglioAttributo2 { get; set; }
        public int? IdRisposteDettaglioMacroAttributo3 { get; set; }
        public int? IdRisposteDettaglioAttributo3 { get; set; }
        public int? IdRisposteDettaglioMacroAttributo4 { get; set; }
        public int? IdRisposteDettaglioAttributo4 { get; set; }
        public int? IdRisposteDettaglioMacroAttributo5 { get; set; }
        public int? IdRisposteDettaglioAttributo5 { get; set; }

        public int IdTipoAudit { get; set; }
        public int IdChecklist { get; set; }

        public string DesTipoDomande { get; set; }

        public bool PrevedeProcesso { get; set; }
        public int? IdProcesso { get; set; }

        public Domande()
        {

        }
    }
}
