﻿using AuditManager.Shared.Attributes;
using SQLite;
using System.Net;

namespace AuditManager.Models.Tables
{
    [Table("Motivazioni"), TableReplication(Replicate = true)]
    public class Motivazioni : BaseTable
    {
        [NotNull]
        public int IdMotivazione { get; set; }

        private string _CodMotivazione;
        [NotNull]
        public string CodMotivazione
        {
            get { return _CodMotivazione; }
            set { _CodMotivazione = WebUtility.HtmlDecode(value); }
        }

        private string _DescMotivazione;
        [NotNull]
        public string DescMotivazione
        {
            get { return _DescMotivazione; }
            set { _DescMotivazione = WebUtility.HtmlDecode(value); }
        }

        public bool? AuditNuovo { get; set; }
        public bool? RisposteNuovo { get; set; }
        public bool? AllegatiNuovo { get; set; }
        public int? GgNuovo { get; set; }
        public int? IdMotivazioneAuditNuovo { get; set; }

        public bool? InvioComunicazione { get; set; }

        public int IdTipoAudit { get; set; }


        [Ignore]
        public string MotivoCompleto { get { return $"{CodMotivazione} - {DescMotivazione}"; } }

        public Motivazioni()
        {

        }
    }
}