﻿using AuditManager.Shared.Attributes;
using SQLite;
using System.Net;

namespace AuditManager.Models.Tables
{
    [Table("Processi"), TableReplication(Replicate = true)]
    public class Processi
    {
        [Unique, NotNull]
        public int IdProcesso { get; set; }

        private string _DescProcesso;
        [NotNull]
        public string DescProcesso
        {
            get { return _DescProcesso; }
            set { _DescProcesso = WebUtility.HtmlDecode(value); }
        }

        private string _NomeProcesso;
        [NotNull]
        public string NomeProcesso
        {
            get { return _NomeProcesso; }
            set { _NomeProcesso = WebUtility.HtmlDecode(value); }
        }

        private string _TestoNCPrimario;
        public string TestoNCPrimario
        {
            get { return _TestoNCPrimario; }
            set { _TestoNCPrimario = WebUtility.HtmlDecode(value); }
        }

        private string _TestoNCSecondario;
        public string TestoNCSecondario
        {
            get { return _TestoNCSecondario; }
            set { _TestoNCSecondario = WebUtility.HtmlDecode(value); }
        }

        private string _TestoNCPoppa;
        public string TestoNCPoppa
        {
            get { return _TestoNCPoppa; }
            set { _TestoNCPoppa = WebUtility.HtmlDecode(value); }
        }

        private string _TestoNCPrua;
        public string TestoNCPrua
        {
            get { return _TestoNCPrua; }
            set { _TestoNCPrua = WebUtility.HtmlDecode(value); }
        }

        public int? Attributo1 { get; set; }
        public int? Attributo2 { get; set; }
        public int? Attributo3 { get; set; }
        public int? Attributo4 { get; set; }
        public int? Attributo5 { get; set; }

        [NotNull]
        public bool PrevedeNc { get; set; }
        [NotNull]
        public bool PrevedeTaratura { get; set; }

        public decimal? TempoRegistrazione { get; set; }
        public decimal? FrequenzaRegistrazione { get; set; }

        public string IdDomanda { get; set; }

        public Processi()
        {

        }
    }
}