﻿using AuditManager.Shared.Attributes;
using SQLite;
using System.Net;

namespace AuditManager.Models.Tables
{
    [Table("Soggetti"), TableReplication(Replicate = true)]
    public class Soggetti : BaseTable
    {
        [NotNull]
        public int IdSoggetto { get; set; }

        private string _DescSoggetto;
        [NotNull]
        public string DescSoggetto
        {
            get { return _DescSoggetto; }
            set { _DescSoggetto = WebUtility.HtmlDecode(value); }
        }

        [NotNull]
        public int IdTipoSoggetto { get; set; }

        private string _Matricola;
        public string Matricola
        {
            get { return _Matricola; }
            set { _Matricola = WebUtility.HtmlDecode(value); }
        }

        private string _Localita;
        public string Localita
        {
            get { return _Localita; }
            set { _Localita = WebUtility.HtmlDecode(value); }
        }

        public string Email { get; set; }
        public string Telefono { get; set; }
        public string Cellulare { get; set; }

        private string _Note;
        public string Note
        {
            get { return _Note; }
            set { _Note = WebUtility.HtmlDecode(value); }
        }

        private string _Divisione;
        public string Divisione
        {
            get { return _Divisione; }
            set { _Divisione = WebUtility.HtmlDecode(value); }
        }

        public string AttributoSoggetto1 { get; set; }
        public string AttributoSoggetto2 { get; set; }
        public string AttributoSoggetto3 { get; set; }
        public string AttributoSoggetto4 { get; set; }
        public string Immagine { get; set; }

        public string CodProdotto { get; set; }
        public string Filtro { get; set; }

        public Soggetti()
        {

        }
    }
}