﻿using AuditManager.Shared.Attributes;
using Newtonsoft.Json;
using SQLite;
using System.Collections.ObjectModel;
using System.Net;

namespace AuditManager.Models.Tables
{
    [Table("Stati"), TableReplication(Replicate = true)]
    public class Stati : BaseTable
    {
        [NotNull]
        public int IdStato { get; set; }

        private string _DescStato;
        [NotNull]
        public string DescStato
        {
            get { return _DescStato; }
            set { _DescStato = WebUtility.HtmlDecode(value); }
        }

        public string ColoreTitolo { get; set; }
        public string ColoreSottoTitolo { get; set; }
        public string Immagine { get; set; }

        [JsonIgnore, Ignore]
        public ObservableCollection<Audit> Audits { get; set; }

        private double _InnerListHeight;
        [JsonIgnore, Ignore]
        public double InnerListHeight
        {
            get { return _InnerListHeight; }
            set
            {
                _InnerListHeight = value;
                OnPropertyChanged(nameof(InnerListHeight));
            }
        }


        public Stati()
        {
            Audits = new ObservableCollection<Audit>();
        }
    }
}