﻿using AuditManager.Shared.Attributes;
using AuditManager.Shared.Types;
using SQLite;
using System.Net;

namespace AuditManager.Models.Tables
{
    [Table("Utenti"), TableReplication(Replicate = true)]
    public class Utenti : BaseTable
    {
        [Unique, NotNull]
        public int IdUtente { get; set; }

        private string _Nome;
        public string Nome
        {
            get { return _Nome; }
            set { _Nome = WebUtility.HtmlDecode(value); }
        }

        private string _Cognome;
        public string Cognome
        {
            get { return _Cognome; }
            set { _Cognome = WebUtility.HtmlDecode(value); }
        }

        public string UserCode { get; set; }
        [NotNull]
        public string Email { get; set; }
        public string Telefono { get; set; }
        public string Cellulare { get; set; }

        private string _Immagine;
        public string Immagine
        {
            get { return _Immagine; }
            set
            {
                _Immagine = value;
                OnPropertyChanged("Immagine");
            }
        }

        private string _Firma;
        public string Firma
        {
            get { return _Firma; }
            set
            {
                _Firma = value;
                OnPropertyChanged("Firma");
            }
        }

        public Themes EnumTema { get; set; }

        public Utenti()
        {

        }
    }
}