﻿using AuditManager.Shared.Attributes;
using Newtonsoft.Json;
using SQLite;
using System.Collections.ObjectModel;
using System.Net;

namespace AuditManager.Models.Tables
{
    [Table("AuditAllegati"), TableReplication(Replicate = true)]
    public class AuditAllegati : AuditBaseTable
    {
        [NotNull]
        public int IdAuditAllegati { get; set; }
        [NotNull]
        public string PathAllegato { get; set; }

        private string _NomeAllegato;
        [NotNull]
        public string NomeAllegato
        {
            get { return _NomeAllegato; }
            set { _NomeAllegato = WebUtility.HtmlDecode(value); }
        }

        [NotNull]
        public bool Supporto { get; set; }
        [JsonIgnore]
        public bool Scaricato { get; set; }
        [NotNull]
        public bool DisponibileOffline { get; set; }
        [NotNull]
        public string TipoDocumento { get; set; }
        public int? Ordine { get; set; }

        private string _Icona;
        public string Icona
        {
            get { return _Icona; }
            set { _Icona = value; }
        }

        [JsonIgnore, Ignore]
        public string PathMappaConNc { get; set; }
        [JsonIgnore, Ignore]
        public double WidthMappaConNc { get; set; }
        [JsonIgnore, Ignore]
        public double HeightMappaConNc { get; set; }
        //[JsonIgnore, Ignore]
        //public ObservableCollection<UIElement> ElementiMappa { get; set; }
        [JsonIgnore, Ignore]
        public bool IconaVisibile { get; set; }

        public AuditAllegati() : base()
        {
            Scaricato = false;
            IconaVisibile = IsVisible(this);
        }

        public bool IsVisible(AuditAllegati allegato)
        {
            bool retValue = true;

            if (allegato.Scaricato == false)
                retValue = false;

            return retValue;
        }
    }
}
