﻿using AuditManager.Shared.Attributes;
using Newtonsoft.Json;
using SQLite;

namespace AuditManager.Models.Tables
{
    [Table("AuditCategorie"), TableReplication(Replicate = true)]
    public class AuditCategorie : Categorie
    {
        [NotNull, Indexed]
        public int IdAudit { get; set; }

        private string _ColoreCategoria = string.Empty;
        [JsonIgnore, Ignore]
        public string ColoreCategoria
        {
            get { return _ColoreCategoria; }
            set
            {
                _ColoreCategoria = value;
                OnPropertyChanged(nameof(ColoreCategoria));
            }
        }

        private int _NumeroOK;
        [JsonIgnore, Ignore]
        public int NumeroOK
        {
            get { return _NumeroOK; }
            set
            {
                _NumeroOK = value;
                OnPropertyChanged(nameof(NumeroOK));
            }
        }

        private bool _BadgeOKVisibile;
        [JsonIgnore, Ignore]
        public bool BadgeOKVisibile
        {
            get { return _BadgeOKVisibile; }
            set
            {
                _BadgeOKVisibile = value;
                OnPropertyChanged(nameof(BadgeOKVisibile));
            }
        }

        private int _NumeroKO;
        [JsonIgnore, Ignore]
        public int NumeroKO
        {
            get { return _NumeroKO; }
            set
            {
                _NumeroKO = value;
                OnPropertyChanged(nameof(NumeroKO));
            }
        }

        private bool _BadgeKOVisibile;
        [JsonIgnore, Ignore]
        public bool BadgeKOVisibile
        {
            get { return _BadgeKOVisibile; }
            set
            {
                _BadgeKOVisibile = value;
                OnPropertyChanged(nameof(BadgeKOVisibile));
            }
        }

        private int _NumeroNA;
        [JsonIgnore, Ignore]
        public int NumeroNA
        {
            get { return _NumeroNA; }
            set
            {
                _NumeroNA = value;
                OnPropertyChanged(nameof(NumeroNA));
            }
        }

        private bool _BadgeNAVisibile;
        [JsonIgnore, Ignore]
        public bool BadgeNAVisibile
        {
            get { return _BadgeNAVisibile; }
            set
            {
                _BadgeNAVisibile = value;
                OnPropertyChanged(nameof(BadgeNAVisibile));
            }
        }

        private int _NumeroNT;
        [JsonIgnore, Ignore]
        public int NumeroNT
        {
            get { return _NumeroNT; }
            set
            {
                _NumeroNT = value;
                OnPropertyChanged(nameof(NumeroNT));
            }
        }

        private bool _BadgeNTVisibile;
        [JsonIgnore, Ignore]
        public bool BadgeNTVisibile
        {
            get { return _BadgeNTVisibile; }
            set
            {
                _BadgeNTVisibile = value;
                OnPropertyChanged(nameof(BadgeNTVisibile));
            }
        }

        private int _NumeroDV;
        [JsonIgnore, Ignore]
        public int NumeroDV
        {
            get { return _NumeroDV; }
            set
            {
                _NumeroDV = value;
                OnPropertyChanged(nameof(NumeroDV));
            }
        }

        private bool _BadgeDVVisibile;
        [JsonIgnore, Ignore]
        public bool BadgeDVVisibile
        {
            get { return _BadgeDVVisibile; }
            set
            {
                _BadgeDVVisibile = value;
                OnPropertyChanged(nameof(BadgeDVVisibile));
            }
        }

        public AuditCategorie() : base()
        {
            NumeroOK = 0;
            NumeroKO = 0;
            NumeroNA = 0;
            NumeroNT = 0;
            NumeroDV = 0;

            BadgeOKVisibile = false;
            BadgeKOVisibile = false;
            BadgeNAVisibile = false;
            BadgeNTVisibile = false;
            BadgeDVVisibile = false;
        }
    }
}
