﻿using AuditManager.Shared.Attributes;
using Newtonsoft.Json;
using SQLite;
using System;
using System.Net;

namespace AuditManager.Models.Tables
{
    [Table("AuditDocumentiEsaminati"), TableReplication(Replicate = true)]
    public class AuditDocumentiEsaminati : AuditBaseTable
    {
        [NotNull]
        public Guid IdDocumentoEsaminato { get; set; }
        [NotNull]
        public int IdRisposta { get; set; }
        public Guid? IdRispostaDettaglio { get; set; }

        private string _Colonna1;
        public string Colonna1
        {
            get { return _Colonna1; }
            set { _Colonna1 = WebUtility.HtmlDecode(value); }
        }

        public DateTime? Colonna2 { get; set; }

        private string _Colonna3;
        public string Colonna3
        {
            get { return _Colonna3; }
            set { _Colonna3 = WebUtility.HtmlDecode(value); }
        }

        private string _Colonna4;
        public string Colonna4
        {
            get { return _Colonna4; }
            set { _Colonna4 = WebUtility.HtmlDecode(value); }
        }

        [NotNull]
        public int IdStatoNcCreazione { get; set; }

        [JsonIgnore, Ignore]
        public bool Selezionato { get; set; }


        public AuditDocumentiEsaminati() : base()
        {
            IdDocumentoEsaminato = Guid.NewGuid();
        }
    }
}
