﻿using AuditManager.Shared.Attributes;
using Newtonsoft.Json;
using SQLite;
using System;
using System.Collections.Generic;
using System.Net;

namespace AuditManager.Models.Tables
{
    [Table("AuditDomandeRisposte"), TableReplication(Replicate = true)]
    public class AuditDomandeRisposte : Domande
    {
        [NotNull]
        public int IdAudit { get; set; }
        [NotNull]
        public bool Sincronizzato { get; set; }
        public DateTime? DataSincronizzato { get; set; }
        [NotNull]
        public DateTime DataCreazione { get; set; }
        [NotNull]
        public bool Attivo { get; set; }
        public DateTime? DataCancellazione { get; set; }

        public int IdRisposta { get; set; }

        private string _Risposta;
        public string Risposta
        {
            get { return _Risposta; }
            set { _Risposta = WebUtility.HtmlDecode(value); }
        }

        private string _Note;
        public string Note
        {
            get { return _Note; }
            set { _Note = WebUtility.HtmlDecode(value); }
        }

        public DateTime DataRisposta { get; set; }
        public bool DomandaCustom { get; set; }
        public bool SincronizzatoCustom { get; set; }
        public DateTime? DataSincronizzatoCustom { get; set; }

        [JsonIgnore, Ignore]
        public int? LengthHelp { get; set; }
        [JsonIgnore, Ignore]
        public bool Domanda1Visibile { get; set; }
        [JsonIgnore, Ignore]
        public bool Domanda2Visibile { get; set; }
        [JsonIgnore, Ignore]
        public bool Domanda3Visibile { get; set; }
        [JsonIgnore, Ignore]
        public bool Domanda4Visibile { get; set; }
        [JsonIgnore, Ignore]
        public bool Domanda5Visibile { get; set; }
        [JsonIgnore, Ignore]
        public bool Domanda6Visibile { get; set; }
        [JsonIgnore, Ignore]
        public bool Domanda7Visibile { get; set; }
        [JsonIgnore, Ignore]
        public bool Domanda8Visibile { get; set; }
        [JsonIgnore, Ignore]
        public bool Domanda9Visibile { get; set; }
        [JsonIgnore, Ignore]
        public bool Domanda10Visibile { get; set; }
        [JsonIgnore, Ignore]
        public bool Domanda11Visibile { get; set; }

        [JsonIgnore, Ignore]
        public bool IsDomandaVisibile { get; set; }

        [JsonIgnore, Ignore]
        public bool AzioniDomandaVisibile { get; set; }


        [JsonIgnore, Ignore]
        public int? NrAllegati { get; set; }
        [JsonIgnore, Ignore]
        public int? NrDettagli { get; set; }

        private bool _ListaAllegatiVisible = false;
        [JsonIgnore, Ignore]
        public bool ListaAllegatiVisible
        {
            get { return _ListaAllegatiVisible; }
            set
            {
                _ListaAllegatiVisible = value;
                OnPropertyChanged(nameof(ListaAllegatiVisible));
            }
        }
        private bool _AggiungiNCVisible = false;
        [JsonIgnore, Ignore]
        public bool AggiungiNCVisible
        {
            get { return _AggiungiNCVisible; }
            set
            {
                _AggiungiNCVisible = value;
                OnPropertyChanged(nameof(AggiungiNCVisible));
            }
        }
        private bool _ListaNCVisible = false;
        [JsonIgnore, Ignore]
        public bool ListaNCVisible
        {
            get { return _ListaNCVisible; }
            set
            {
                _ListaNCVisible = value;
                OnPropertyChanged(nameof(ListaNCVisible));
            }
        }
        private bool _AzzeraRispostaVisible = false;
        [JsonIgnore, Ignore]
        public bool AzzeraRispostaVisible
        {
            get { return _AzzeraRispostaVisible; }
            set
            {
                _AzzeraRispostaVisible = value;
                OnPropertyChanged(nameof(AzzeraRispostaVisible));
            }
        }
        private bool _HelpVisible = false;
        [JsonIgnore, Ignore]
        public bool HelpVisible
        {
            get { return _HelpVisible; }
            set
            {
                _HelpVisible = value;
                OnPropertyChanged(nameof(HelpVisible));
            }
        }
        private bool _ProcessoVisible = false;
        [JsonIgnore, Ignore]
        public bool ProcessoVisible
        {
            get { return _ProcessoVisible; }
            set
            {
                _ProcessoVisible = value;
                OnPropertyChanged(nameof(ProcessoVisible));
            }
        }
        private bool _CancellaDomandaVisible = false;
        [JsonIgnore, Ignore]
        public bool CancellaDomandaVisible
        {
            get { return _CancellaDomandaVisible; }
            set
            {
                _CancellaDomandaVisible = value;
                OnPropertyChanged(nameof(CancellaDomandaVisible));
            }
        }

        private double heightPopUpDomanda;
        [JsonIgnore, Ignore]
        public double HeightPopUpDomanda
        {
            get { return heightPopUpDomanda; }
            set
            {
                heightPopUpDomanda = value;
                OnPropertyChanged(nameof(HeightPopUpDomanda));
            }
        }

        private string _ColoreRisposta;
        [JsonIgnore, Ignore]
        public string ColoreRisposta
        {
            get { return _ColoreRisposta; }
            set
            {
                _ColoreRisposta = value;
                OnPropertyChanged(nameof(ColoreRisposta));
            }
        }

        private string _ImmagineCheckOK;
        [JsonIgnore, Ignore]
        public string ImmagineCheckOK
        {
            get { return _ImmagineCheckOK; }
            set
            {
                _ImmagineCheckOK = value;
                OnPropertyChanged(nameof(ImmagineCheckOK));
            }
        }
        private string _ImmagineCheckKO;
        [JsonIgnore, Ignore]
        public string ImmagineCheckKO
        {
            get { return _ImmagineCheckKO; }
            set
            {
                _ImmagineCheckKO = value;
                OnPropertyChanged(nameof(ImmagineCheckKO));
            }
        }
        private string _ImmagineCheckNA;
        [JsonIgnore, Ignore]
        public string ImmagineCheckNA
        {
            get { return _ImmagineCheckNA; }
            set
            {
                _ImmagineCheckNA = value;
                OnPropertyChanged(nameof(ImmagineCheckNA));
            }
        }
        private string _ImmagineCheckNT;
        [JsonIgnore, Ignore]
        public string ImmagineCheckNT
        {
            get { return _ImmagineCheckNT; }
            set
            {
                _ImmagineCheckNT = value;
                OnPropertyChanged(nameof(ImmagineCheckNT));
            }
        }


        public AuditDomandeRisposte() : base()
        {
            Sincronizzato = false;
            Attivo = true;
            DataCreazione = DateTime.Now;
            DataRisposta = DateTime.Now;
            DomandaCustom = false;
            SincronizzatoCustom = false;

            IsDomandaVisibile = true;
            AzioniDomandaVisibile = false;

            HelpVisible = !string.IsNullOrEmpty(Help) || !string.IsNullOrEmpty(HelpAllegato);
            LengthHelp = (Help?.Length);

            ProcessoVisible = PrevedeProcesso;

            Domanda1Visibile = false;
            Domanda2Visibile = false;
            Domanda3Visibile = false;
            Domanda4Visibile = false;
            Domanda5Visibile = false;
            Domanda6Visibile = false;
            Domanda7Visibile = false;
            Domanda8Visibile = false;
            Domanda9Visibile = false;
            Domanda10Visibile = false;
            Domanda11Visibile = false;

            ImmagineCheckOK = "indicatore_white_small.png";
            ImmagineCheckKO = "indicatore_white_small.png";
            ImmagineCheckNA = "indicatore_white_small.png";
            ImmagineCheckNT = "indicatore_white_small.png";
        }
    }
}