﻿using AuditManager.Shared.Attributes;
using Newtonsoft.Json;
using SQLite;
using System;

namespace AuditManager.Models.Tables
{
    [Table("AuditEvidenze"), TableReplication(Replicate = true)]
    public class AuditEvidenze : AuditBaseTable
    {
        [NotNull]
        public Guid IdAllegato { get; set; }
        [NotNull]
        public int IdRisposta { get; set; }
        public Guid? IdRispostaDettaglio { get; set; }
        public string Allegato { get; set; }
        public DateTime DataAllegato { get; set; }
        [NotNull]
        public int IdStatoNcCreazione { get; set; }

        [JsonIgnore, Ignore]
        public string Immagine { get; set; }
        [JsonIgnore, Ignore]
        public bool Scaricato { get; set; }

        public AuditEvidenze() : base()
        {
            IdAllegato = Guid.NewGuid();
            DataAllegato = DateTime.Now;
            Scaricato = true;
            Immagine = "file_evidenza.png";
        }
    }
}
