﻿using AuditManager.Shared.Attributes;
using SQLite;
using System;
using System.Net;

namespace AuditManager.Models.Tables
{
    [Table("AuditRisposteDettaglio"), TableReplication(Replicate = true)]
    public class AuditRisposteDettaglio : BaseTable
    {
        [NotNull]
        public int IdAudit { get; set; }
        [NotNull]
        public int IdRisposta { get; set; }
        [NotNull]
        public Guid IdRispostaDettaglio { get; set; }

        private string _Testo;
        public string Testo
        {
            get { return _Testo; }
            set { _Testo = WebUtility.HtmlDecode(value); }
        }
        public int? IdRisposteDettaglioMacroAttributo1 { get; set; }
        public int? IdRisposteDettaglioAttributo1 { get; set; }
        public int? IdRisposteDettaglioMacroAttributo2 { get; set; }
        public int? IdRisposteDettaglioAttributo2 { get ; set ; }
        public int? IdRisposteDettaglioMacroAttributo3 { get; set; }
        public int? IdRisposteDettaglioAttributo3 { get; set; }
        public int? IdRisposteDettaglioMacroAttributo4 { get; set; }
        public int? IdRisposteDettaglioAttributo4 { get; set; }
        public int? IdRisposteDettaglioMacroAttributo5 { get; set; }
        public int? IdRisposteDettaglioAttributo5 { get; set; }
        public DateTime DataRisposta { get; set; }
        public int IdStatoNC { get; set; }

        private string _Nota;
        public string Nota { get { return _Nota; } set { _Nota = WebUtility.HtmlDecode(value); } }

        public DateTime? DataPrevistaRisoluzione { get; set; }

        public int? IdUtenteModifica { get; set; }
        public DateTime? DataModifica { get; set; }
        [NotNull]
        public bool Sincronizzato { get; set; }
        public DateTime? DataSincronizzato { get; set; }
        [NotNull]
        public DateTime DataCreazione { get; set; }
        [NotNull]
        public bool Attivo { get; set; }
        public DateTime? DataCancellazione { get; set; }
        public int? IdAllegatoCommento { get; set; }
        public Guid? IdAllegatoPerAzione { get; set; }
        public decimal? CoordinataX { get; set; }
        public decimal? CoordinataY { get; set; }
        public string NomeMappa { get; set; }
        public bool? IsMappata { get; set; }
        public Guid? NcMultipla { get; set; }
        public string TypeRP { get; set; }

        public AuditRisposteDettaglio() : base()
        {
            IdRispostaDettaglio = Guid.NewGuid();
            Attivo = true;
            Sincronizzato = false;
            DataRisposta = DateTime.Now;
            DataCreazione = DateTime.Now;
        }
    }
}