﻿using Newtonsoft.Json;
using SQLite;
using System;
using System.ComponentModel;

namespace AuditManager.Models.Tables
{
    [Serializable]
    public class BaseTable : INotifyPropertyChanged
    {
        [PrimaryKey, Unique, NotNull, AutoIncrement]
        public int PKID { get; set; }

        private bool? _IsSelected;
        [JsonIgnore, Ignore]
        public bool? IsSelected
        {
            get { return _IsSelected; }
            set
            {
                _IsSelected = value;
                OnPropertyChanged(nameof(IsSelected));
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public BaseTable()
        {
            IsSelected = false;
        }

        protected void OnPropertyChanged(string name)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(name));
        }
    }
}
