﻿namespace AuditManager.Shared.Helpers
{
    public class SharedUtils
    {
        public static string GetFileIcon(string fileName)
        {
            string retValue = string.Empty;

            if (!string.IsNullOrEmpty(fileName))
            {
                string extension = fileName.Substring(fileName.LastIndexOf(".") + 1).ToLower();

                switch (extension)
                {
                    case "pdf":
                        retValue = "icon_pdf.png";
                        break;
                    case "xls":
                    case "xlsx":
                        retValue = "icon_excel.png";
                        break;
                    case "accdb":
                    case "mdb":
                        retValue = "icon_access.png";
                        break;
                    case "mp3":
                        retValue = "icon_audio.png";
                        break;
                    case "dwg":
                        retValue = "icon_dwg.png";
                        break;
                    case "bmp":
                    case "png":
                    case "gif":
                    case "jpg":
                    case "jpeg":
                        retValue = "icon_image.png";
                        break;
                    case "url":
                        retValue = "icon_link.png";
                        break;
                    case "ppt":
                    case "pptx":
                        retValue = "icon_powerpoint.png";
                        break;
                    case "txt":
                        retValue = "icon_txt.png";
                        break;
                    case "mp4":
                    case "mpg":
                        retValue = "icon_video.png";
                        break;
                    case "doc":
                    case "docx":
                        retValue = "icon_word.png";
                        break;
                    case "zip":
                    case "rar":
                    case "tar":
                    case "7z":
                        retValue = "icon_zip.png";
                        break;
                    default:
                        retValue = "icon_generico.png";
                        break;
                }
            }

            return retValue;
        }
    }
}
