﻿namespace AuditManager.Shared.Types
{
    public class ApiResponse<T>
    {
        public T Response { get; set; }

        public string ErrorMessage { get; set; }

        public ApiStatus Status { get; set; }

        public bool IsSuccess => Status == ApiStatus.Ok;
    }

    public enum ApiStatus
    {
        Error,
        Ok,
        Exception,
        NoConnectivity,
        UnAuthorized,
        NotFound,
        TokenExpired
    }
}